
//_______________________________________________________________________________________________________________
/****************************************************************************************************************/
/*                                                                                                              */
/*                     P O I N T E R S   T O   M E S S A G E S                                                  */
/*                                                                                                              */
/****************************************************************************************************************/
//        
#if defined(OS_ENABLE_INT_SERVICE)
    #define __OS_MSG_DI()       {_OS_temp = OS_DI();}
    #define __OS_MSG_RI()       {OS_RI(_OS_temp);}
#else
    #define __OS_MSG_DI()
    #define __OS_MSG_RI()
#endif


//------------------------------------------------------------------------------
// ,   
#define OS_CheckMsg(pmsg)          ((pmsg).status & 1)
#define OS_CheckMsg2(pmsg)          ((pmsg).status)

//------------------------------------------------------------------------------
// / 
#define OS_CreateMsg(pmsg)         {pmsg.status = 0; pmsg.msg = (OST_MSG)0;}
#define OS_ClearMsg(pmsg)          {pmsg.status = 0;}


//------------------------------------------------------------------------------
//  
#define OS_SendMsg(pmsg, value)                                             \
    {                                                                       \
        __OS_MSG_DI();                                                      \
        if (OS_CheckMsg(pmsg)) _OS_WAIT_EVENT(!OS_CheckMsg(pmsg));          \
        pmsg.status = 1;                                                    \
        pmsg.msg = (OST_MSG) value;                                         \
        __OS_MSG_RI();                                                      \
    }

//------------------------------------------------------------------------------
//  ,  ,    
#define OS_SendMsgNoWait(pmsg, value)                                       \
    {                                                                       \
        OS_Flags.bEventError = 0;                                           \
        if (OS_CheckMsg(pmsg)) OS_Flags.bEventError = 1;                    \
        pmsg.status = 1;                                                    \
        pmsg.msg = (OST_MSG) value;                                         \
    }

//------------------------------------------------------------------------------
#ifdef OS_ENABLE_INT_SERVICE
//    
#define OS_IntSendMsgNoWait(pmsg, value)                                    \
    {                                                                       \
        OS_Flags.bEventError = 0;                                           \
        if (OS_CheckMsg(pmsg)) OS_Flags.bEventError = 1;                    \
        pmsg.status = 1;                                                    \
        pmsg.msg = (OST_MSG) value;                                         \
    }
#endif

//------------------------------------------------------------------------------
//    
#define OS_SendMsgTimeout(pmsg, value,timeout)                              \
    {                                                                       \
        if (OS_CheckMsg(pmsg))                                              \
        {                                                                   \
            _OS_WAIT_EVENT_TIMEOUT(!OS_CheckMsg(pmsg), timeout);            \
            if (!OS_IsTimeout()){                                           \
                pmsg.status = 1;                                            \
                pmsg.msg = (OST_MSG) value;                                 \
            }                                                               \
        } else {                                                            \
            pmsg.status = 1;                                                \
            pmsg.msg = (OST_MSG) value;                                     \
        }                                                                   \
    }

//------------------------------------------------------------------------------
//  .
//        var  OST_MSG
#define OS_WaitMsg(pmsg, os_msg_type_var)                           \
    {                                                               \
        _OS_WAIT_EVENT(OS_CheckMsg(pmsg));                          \
        os_msg_type_var = pmsg.msg;                                 \
        OS_ClearMsg(pmsg);                                          \
    }


//------------------------------------------------------------------------------
//    .
//        var  OST_MSG
#define OS_WaitMsgTimeout(pmsg, os_msg_type_var,timeout)            \
    {                                                               \
        os_msg_type_var = (OST_MSG) 0;                              \
        _OS_WAIT_EVENT_TIMEOUT(OS_CheckMsg(pmsg), timeout);         \
        if (!OS_IsTimeout()) {                                      \
            os_msg_type_var = pmsg.msg;                             \
            OS_ClearMsg(pmsg);                                      \
        }                                                           \
    }


//------------------------------------------------------------------------------
//   .      
//   ,   .     
// 
#define OS_AcceptMsg(pmsg, os_msg_type_var)                         \
    {                                                               \
        os_msg_type_var = pmsg.msg;                                 \
        OS_ClearMsg(pmsg);                                          \
    }
