

//_______________________________________________________________________________________________________________
/****************************************************************************************************************/
/*                                                                                                              */
/*                     P T I M E R S                                                                            */
/*                                                                                                              */
/****************************************************************************************************************/

#ifdef OS_ENABLE_PTIMERS

/************************************************************************/
/*                                              */
/************************************************************************/

#define OS_CheckPTimer(ptimer)      ((ptimer).Flags.bTimeout)       //   
#define OS_IsPTimerActive(ptimer)   ((ptimer).Flags.bActive)        //        
#define OS_IsPTimerStopped(ptimer)  (!((ptimer).Flags.bRun))        //   
#define OS_IsPTimerRun(ptimer)      ((ptimer).Flags.bRun)           //   

#define OS_StopPTimer(ptimer)          (ptimer).Flags.bRun = 0        //  
#define OS_PausePTimer(ptimer)         (ptimer).Flags.bRun = 0        //  
#define OS_ContinuePTimer(ptimer)      (ptimer).Flags.bRun = 1        //   

#define OS_BreakPTimer(ptimer)         (ptimer).Flags.bTimeout = 1     //   

/************************************************************************/
/*      time.                             */
/************************************************************************/
#define OS_RunPTimer(ptimer, time)          \
    {                                       \
        (ptimer).Flags.bRun = 0;            \
        (ptimer).Timer = -time;             \
        (ptimer).Flags.bTimeout = 0;        \
        (ptimer).Flags.bRun = 1;            \
    }

/************************************************************************/
/*      time   ,        */
/*                                      */
/************************************************************************/
#define OS_UpdatePTimer(ptimer, time)       \
    {                                       \
        (ptimer).Flags.bRun = 0;            \
        (ptimer).Timer -= time;             \
        (ptimer).Flags.bTimeout = 0;        \
        (ptimer).Flags.bRun = 1;            \
    }

/************************************************************************/
/*     time.                                       */
/************************************************************************/
#define OS_AddPTimer(ptimer, time)          \
    {                                       \
        (ptimer).Flags.bRun = 0;            \
        (ptimer).Timer -= time;             \
        (ptimer).Flags.bRun = 1;            \
    }

/************************************************************************/
/*                                               */
/************************************************************************/
#define OS_GetPTimer(ptimer)      (-(ptimer).Time)

/************************************************************************/
/*                                        */
/************************************************************************/
#define OS_WaitPTimer(ptimer)                   \
    {                                           \
        _OS_WAIT_EVENT(OS_CheckPTimer(ptimer)); \
    }


/************************************************************************/
/*         */
/************************************************************************/
#define OS_DelayPTimer(ptimer, delay)       \
    {                                       \
        OS_RunPTimer(ptimer, delay);        \
        OS_WaitPTimer(ptimer);              \
    }



#endif  // OS_ENABLE_PTIMERS

