
//_______________________________________________________________________________________________________________
/****************************************************************************************************************/
/*                                                                                                              */
/*                     Q U E U E   O F   S I M P L E    M E S S A G E S                                         */
/*                                                                                                              */
/****************************************************************************************************************/

#ifdef OS_ENABLE_QSMSG



    #if defined(OS_QMSG_QSMSG_IDENTICAL)
        //         ,  
        //      
        #define _OS_SendQSMsg(pQSMsg,SMsg)  _OS_SendQMsg((OST_QMSG*)pQSMsg, (OST_MSG)SMsg)
        #define _OS_GetQSMsg(pQSMsg)        _OS_GetQMsg((OST_QMSG*)pQSMsg)
    #else
        extern void         _OS_SendQSMsg (OST_QSMSG *pQSMsg, OST_SMSG SMsg);
        extern OST_SMSG     _OS_GetQSMsg (OST_QSMSG *pQSMsg);
    #endif

//------------------------------------------------------------------------------
//    

#define OS_CreateQSMsg(qsmsg, buffer, size)                 \
    {                                                       \
        (qsmsg).Q.cSize = size;                             \
        (qsmsg).Q.cBegin = 0;                               \
        (qsmsg).Q.cFilled = 0;                              \
        (qsmsg).pSMsg = (OST_SMSG*)buffer;                  \
    }

//------------------------------------------------------------------------------
//        
#define OS_CheckQSMsg(qsmsg)        ((qsmsg).Q.cFilled)

//------------------------------------------------------------------------------
//    
#define OS_IsQSMsgFull(qsmsg)       ((qsmsg).Q.cFilled == (qsmsg).Q.cSize)

//------------------------------------------------------------------------------
// ,     
#define OS_IsQSMsgFree(qsmsg)       ((qsmsg).Q.cFilled ^ (qsmsg).Q.cSize)


//------------------------------------------------------------------------------
//   
#define OS_ClearQSMsg(qsmsg)        { (qsmsg).Q.cFilled = 0; }

//------------------------------------------------------------------------------
//     
#define OS_SendQSMsg(qsmsg, value)                                      \
    {                                                                   \
        if (OS_IsQSMsgFull(qsmsg))                                      \
            _OS_WAIT_EVENT(OS_IsQSMsgFree(qsmsg));                      \
        _OS_SendQSMsg(&(qsmsg), value);                                 \
    }                                                                   \

//------------------------------------------------------------------------------
//       
#define OS_SendQSMsgTimeout(qsmsg, value, timeout)                      \
    {                                                                   \
        if (OS_IsQSMsgFull(qsmsg))                                      \
        {                                                               \
            _OS_WAIT_EVENT_TIMEOUT(OS_IsQSMsgFree(qsmsg), timeout);     \
            if (!OS_IsTimeout()) {                                      \
                _OS_SendQSMsg(&(qsmsg), value);                         \
            }                                                           \
        } else _OS_SendQSMsg(&(qsmsg), value);                          \
    }

//------------------------------------------------------------------------------
//           
#define OS_SendQSMsgNoWait(qsmsg, value)                                \
    {                                                                   \
        _OS_SendQSMsg(&(qsmsg), value);                                 \
    }


//------------------------------------------------------------------------------
//     
#define OS_WaitQSMsg(qsmsg, os_smsg_type_var)                           \
    {                                                                   \
        _OS_WAIT_EVENT(OS_CheckQSMsg(qsmsg));                           \
        os_smsg_type_var = _OS_GetQSMsg(&(qsmsg));                      \
    }

//------------------------------------------------------------------------------
//       
#define OS_WaitQSMsgTimeout(qsmsg, os_smsg_type_var, timeout)           \
    {                                                                   \
        _OS_WAIT_EVENT_TIMEOUT(OS_CheckQSMsg(qsmsg), timeout);          \
        if (!OS_IsTimeout())                                            \
        {                                                               \
            os_smsg_type_var = _OS_GetQSMsg(&(qsmsg));                  \
        }                                                               \
    }

//------------------------------------------------------------------------------
//      (    ,   )
#define OS_AcceptQSMsg(qsmsg)    _OS_GetQSMsg(&(qsmsg))







#endif













