#ifdef OS_ENABLE_STIMERS


#if     OS_STIMER_SIZE == 1
    #define OS_STIMER_RUN   0x80
#elif   OS_STIMER_SIZE == 2
    #define OS_STIMER_RUN   0x8000
#elif   OS_STIMER_SIZE == 4
    #define OS_STIMER_RUN   0x80000000
#endif


/************************************************************************/
/*                                  */
/************************************************************************/
#define OS_CheckSTimer(stimer_id)   (!(OS_STimers[stimer_id] & OS_STIMER_RUN))
#define OS_IsSTimerRun(stimer_id)   (OS_STimers[stimer_id] & OS_STIMER_RUN)


/************************************************************************/
/*                                               */
/************************************************************************/

#define OS_RunSTimer(stimer_id, time)   \
    {                                   \
        OS_StopSTimer(stimer_id);       \
        OS_STimers[stimer_id] = -(time); \
    }
    //        RUN, ..  , 
    //    ,        
    //   1     7F... 


/************************************************************************/
/* /                                       */
/************************************************************************/

#define OS_StopSTimer(stimer_id)    OS_STimers[stimer_id] &= ~OS_STIMER_RUN
#define OS_PauseSTimer(stimer_id)    OS_STimers[stimer_id] &= ~OS_STIMER_RUN


/************************************************************************/
/*                                          */
/************************************************************************/
//  OS_Timer   ,     
//   .
#define OS_GetSTimer(stimer_id)    (OS_CheckSTimer(stimer_id)? 0:(-OS_STimers[stimer_id]))

/************************************************************************/
/*                                                 */
/************************************************************************/

#define OS_ContinueSTimer(stimer_id)    OS_STimers[stimer_id] |= OS_STIMER_RUN


/************************************************************************/
/*                                        */
/************************************************************************/
#define OS_WaitSTimer(stimer_id)                    \
    {                                               \
        _OS_WAIT_EVENT(OS_CheckSTimer(stimer_id));  \
    }


/************************************************************************/
/*         */
/************************************************************************/
#define OS_DelaySTimer(stimer_id, delay)    \
    {                                       \
        OS_RunSTimer(stimer_id, delay);     \
        OS_WaitSTimer(stimer_id);           \
    }



#endif  // OS_ENABLE_STIMERS





